import { ElementRef, EventEmitter, OnDestroy, OnInit, Renderer2, TemplateRef, ViewContainerRef } from '@angular/core';
import { CdkOverlayOrigin, Overlay, OverlayConfig, OverlayRef } from '@angular/cdk/overlay';
import { TemplatePortal } from '@angular/cdk/portal';
export declare class NzDrawerComponent implements OnInit, OnDestroy {
    private renderer;
    private overlay;
    private elementRef;
    private viewContainerRef;
    origin: CdkOverlayOrigin;
    overlayRef: OverlayRef;
    portal: TemplatePortal;
    isOpen: boolean;
    readonly transform: string;
    readonly width: string;
    drawerTemplate: TemplateRef<{}>;
    nzClosable: boolean;
    nzMaskClosable: boolean;
    nzMask: boolean;
    nzTitle: string | TemplateRef<{}>;
    nzMaskStyle: object;
    nzBodyStyle: object;
    nzWrapClassName: string;
    nzWidth: number | string;
    nzPlacement: 'left' | 'right';
    nzZIndex: number;
    nzOffsetX: number;
    nzOnClose: EventEmitter<MouseEvent>;
    nzVisible: boolean;
    isNonEmptyString(value: {}): boolean;
    isTemplateRef(value: {}): boolean;
    constructor(renderer: Renderer2, overlay: Overlay, elementRef: ElementRef, viewContainerRef: ViewContainerRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    attachOverlay(): void;
    disposeOverlay(): void;
    getOverlayConfig(): OverlayConfig;
    updateOverlayStyle(): void;
    close(e?: MouseEvent): void;
    maskClick(e: MouseEvent): void;
}
